package com.unipi.talepis.softeng2023_4;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AlertDialog;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.app.ActivityCompat;

import android.Manifest;
import android.content.pm.PackageManager;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.view.View;
import android.widget.TextView;

public class MainActivity extends AppCompatActivity implements LocationListener {
    LocationManager locationManager;
    TextView textView;
    SQLiteDatabase database;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        textView = findViewById(R.id.textView);
        locationManager = (LocationManager) getSystemService(LOCATION_SERVICE);
        database = openOrCreateDatabase("mydb.db",MODE_PRIVATE,null);
        database.execSQL("Create table if not exists Contact(" +
                "fullname Text," +
                "email Text Primary Key," +
                "telephone Text)");
        database.execSQL("Insert or ignore into Contact Values('John','j1@hotmail.com','2104142000')");
    }

    public void select(View view){
        Cursor cursor = database.rawQuery("Select * from Contact",null);
        StringBuilder data = new StringBuilder();
        while (cursor.moveToNext()){
            data.append("Name:"+cursor.getString(0)+"\n");
            data.append("Telephone:"+cursor.getString(2)+"\n");
            data.append("-----------------\n");
        }
        showMessage("Contacts",data.toString());
    }

    public void insert(View view){
        database.execSQL("Insert into Contact Values('Katerina','kat@unipi.com','+306923454323')");
    }

    private void showMessage(String Title,String message){
        new AlertDialog.Builder(this)
                .setTitle(Title)
                .setMessage(message)
                .show();
    }

    public void gps(View view) {
        if (ActivityCompat.checkSelfPermission(this,
                android.Manifest.permission.ACCESS_FINE_LOCATION) != PackageManager.PERMISSION_GRANTED)
                 {
                     ActivityCompat.requestPermissions(
                             this,new String[]{Manifest.permission.ACCESS_FINE_LOCATION},123);
            return;
        }
        locationManager.requestLocationUpdates(LocationManager.GPS_PROVIDER, 0, 0, this);
        //locationManager.removeUpdates(this);
    }

    @Override
    public void onLocationChanged(@NonNull Location location) {
        textView.setText(String.valueOf(location.getLatitude())+","+String.valueOf(location.getLongitude()));
    }
}